
#include <windows.h>
#include <streams.h>
#include <initguid.h>
#include "SizeSelect_Dialog.hpp"
#include "VideoResizer.hpp"
#include "VideoResizer_Filter.hpp"
#include "registry.h"

extern "C" BOOL FPU_enabled;
extern "C" BOOL MMX_enabled;
BOOL MMX_enabled = 1;
BOOL FPU_enabled = 1;

// {AA59CBFA-F731-49e9-BE78-08665F339EFC}
DEFINE_GUID(CLSID_VideoResizer, 
0xaa59cbfa, 0xf731, 0x49e9, 0xbe, 0x78, 0x8, 0x66, 0x5f, 0x33, 0x9e, 0xfc);

// {F452A7FF-1F17-41bf-ABEA-006FA9B6096E}
DEFINE_GUID(CLSID_About_PropertyPage, 
0xf452a7ff, 0x1f17, 0x41bf, 0xab, 0xea, 0x0, 0x6f, 0xa9, 0xb6, 0x9, 0x6e);

// Setup data

const AMOVIESETUP_MEDIATYPE sudPinTypesIn =
{
	&MEDIATYPE_Video,       // Major type
    &MEDIASUBTYPE_YUY2,     // Minor type
};

const AMOVIESETUP_MEDIATYPE sudPinTypesOut =
{
    &MEDIATYPE_Video,       // Major type
    &MEDIASUBTYPE_YUY2,     // Minor type
};

const AMOVIESETUP_PIN sudpPins[] =
{
    { L"Input",             // Pins string name
      FALSE,                // Is it rendered
      FALSE,                // Is it an output
      FALSE,                // Are we allowed none
      FALSE,                // And allowed many
      &CLSID_NULL,          // Connects to filter
      NULL,            // Connects to pin
      1,                    // Number of types
      &sudPinTypesIn        // Pin information
    },
    { L"Output",            // Pins string name
      FALSE,                // Is it rendered
      TRUE,                 // Is it an output
      FALSE,                // Are we allowed none
      FALSE,                // And allowed many
      &CLSID_NULL,          // Connects to filter
      NULL,                 // Connects to pin
      1,                    // Number of types
      &sudPinTypesOut       // Pin information
    },
};

const AMOVIESETUP_FILTER sudSourceFilter =
{ 
	&CLSID_VideoResizer,
	L"Bicubic Video Resizer",
	MERIT_PREFERRED+2,
	//MERIT_DO_NOT_USE,
	2,
	sudpPins
};



CFactoryTemplate g_Templates[] =
{
	{
		L"Bicubic Video Resizer",
		&CLSID_VideoResizer,
		VideoResizer_Filter::CreateInstance,
		NULL,
		&sudSourceFilter
	},
	{
		L"I-Media Video Resizer : About Property Page",
		&CLSID_About_PropertyPage,
		SizeSelect_Dialog::CreateInstance
	}
};

int g_cTemplates = 2;


// The streams.h DLL entrypoint.
extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);

// The entrypoint required by the MSVC runtimes. This is used instead
// of DllEntryPoint directly to ensure global C++ classes get initialised.
BOOL WINAPI DllMain(HANDLE hDllHandle, DWORD dwReason, LPVOID lpreserved) {

    return DllEntryPoint(reinterpret_cast<HINSTANCE>(hDllHandle), dwReason, lpreserved);
}

//
// DllRegisterSever
//
// Handle the registration of this filter
//
STDAPI DllRegisterServer( void )
{
	return AMovieDllRegisterServer2 (TRUE);
}


//
// DllUnregisterServer
//
STDAPI DllUnregisterServer( void )
{
	return AMovieDllRegisterServer2 (FALSE);
}